/*
 * SummationLoop.java
 * We sum all the number from 1 to "max"
 * We liberally add "helper methods".
 * They do the work.
 * Thus, the loop code very simple
 * */

public class SummationLoop {

	private int max;
	private int counter;
	private int sum;

	public SummationLoop(int aMax) {
		this.max = aMax;
		this.counter = 0;
		this.sum = 0;
	}

	//------------------------------------------------
	//Looping Helpers

	public void printSum() {
		prnf("Sum is %d", sum);
	}

	public void incrementCount() {
		this.counter++;
	}

	public void increaseSum() {
		this.sum += counter;
	}

	public boolean canContinue() {
		//We can continue if counter <= max
		return this.counter <= this.max;
	}

	//------------------------------------------------
	//Loop

	public void loopSendingMessages() {
		int sum = 0;
		while (this.canContinue()) {
			this.increaseSum();
			this.incrementCount();
		}
		this.printSum();
	}


	//------------------------------------------------
	//Basic Helpers

	static private void prn(Object o) {
		System.out.println(o);
	}

	static private void prnf(String template, Object... params) {
		System.out.printf(template, params);
	}

	static private void header(String title) {
		prnf("----------------------------%n");
		prnf("%s%n%n", title);
	}

	//------------------------------------------------
	//Main Code Entry Point

	public static void main(String[] args) {
		SummationLoop lab = new SummationLoop(4);
		lab.loopSendingMessages();
		prn("");
	}

}


